/* gdl_check_range.h
 * 
 * Copyright (C) 2003, 2004 Brian Gough
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GDL_CHECK_RANGE_H__
#define __GDL_CHECK_RANGE_H__

#include <stdlib.h>
#include <gdl/gdl_common.h>
#include <gdl/gdl_types.h>

__BEGIN_DECLS

GDL_VAR int gdl_check_range;

/* Turn range checking on by default, unless the user defines
   GDL_RANGE_CHECK_OFF, or defines GDL_RANGE_CHECK to 0 explicitly */

#ifdef GDL_RANGE_CHECK_OFF
# ifndef GDL_RANGE_CHECK
#  define GDL_RANGE_CHECK 0
# else
#  error "cannot set both GDL_RANGE_CHECK and GDL_RANGE_CHECK_OFF"
# endif
#else
# ifndef GDL_RANGE_CHECK
#  define GDL_RANGE_CHECK 1
# endif
#endif

__END_DECLS

#endif /* __GDL_CHECK_RANGE_H__ */
