/*  
 *  graphics/text2D.c
 * 
 *  $Author: baptiste $, $Date: 2008-05-13 15:33:52 $, $Version$
 *
 *  Libgdl : a C library for statistical genetics
 * 
 *  Copyright (C) 2003-2006  Jean-Baptiste Veyrieras, INRA, France.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA * 
 */
#include <gdl/gdl_common.h> 
#include <gdl/gdl_errno.h> 
#include <gdl/gdl_graphics.h>

/**
 * 
 */
void
gdl_graphics2D_draw_text(gdl_graphics2D_ptr graph, double x, double y, const char *text)
{
	double xx,yy;
	
	gdl_graphics2D_transform(graph, x, y, &xx, &yy);
	
	switch(graph->device) {
		case GDL_GRAPHICS_DEVICE_PS	:
		    gdl_graphics2D_draw_text_ps(graph, xx, yy, text);
			break;
		case GDL_GRAPHICS_DEVICE_SVG :
		    gdl_graphics2D_draw_text_svg(graph, xx, yy, text); 
			break;
		default :
			break;
	}
}
